Package com.io7m.waxmill.xml.config.v1

# Class WXM1ZFSFilesystems

java.lang.Object
com.io7m.waxmill.xml.config.v1.WXM1ZFSFilesystems

All Implemented Interfaces:
  `WXM1ZFSFilesystemsType`

    public final class WXM1ZFSFilesystems
    extends java.lang.Object
    implements WXM1ZFSFilesystemsType

Immutable implementation of `WXM1ZFSFilesystemsType`.

Use the builder to create immutable instances: `WXM1ZFSFilesystems.builder()`. Use the static factory method to create immutable instances: `WXM1ZFSFilesystems.of()`.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `WXM1ZFSFilesystems.Builder` | Builds instances of type `WXM1ZFSFilesystems`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static WXM1ZFSFilesystems.Builder` | `builder()` | Creates a builder for `WXM1ZFSFilesystems`.
  `static WXM1ZFSFilesystems` | `copyOf​(WXM1ZFSFilesystemsType instance)` | Creates an immutable copy of a `WXM1ZFSFilesystemsType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `WXM1ZFSFilesystems` that have equal attribute values.
  `java.util.List<WXM1ZFSFilesystem>` | `filesystems()` |
  `int` | `hashCode()` | Computes a hash code from attributes: `filesystems`, `pathMap`.
  `static WXM1ZFSFilesystems` | `of​(java.lang.Iterable<? extends WXM1ZFSFilesystem> filesystems)` | Construct a new immutable `WXM1ZFSFilesystems` instance.
  `static WXM1ZFSFilesystems` | `of​(java.util.List<WXM1ZFSFilesystem> filesystems)` | Construct a new immutable `WXM1ZFSFilesystems` instance.
  `java.util.Map<java.lang.String,​WXM1ZFSFilesystem>` | `pathMap()` |
  `java.lang.String` | `toString()` | Prints the immutable value `WXM1ZFSFilesystems` with attribute values.
  `WXM1ZFSFilesystems` | `withFilesystems​(WXM1ZFSFilesystem... elements)` | Copy the current immutable object with elements that replace the content of `filesystems`.
  `WXM1ZFSFilesystems` | `withFilesystems​(java.lang.Iterable<? extends WXM1ZFSFilesystem> elements)` | Copy the current immutable object with elements that replace the content of `filesystems`.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### filesystems

    public java.util.List<WXM1ZFSFilesystem> filesystems()
    Specified by:
      `filesystems` in interface `WXM1ZFSFilesystemsType`
    Returns:
      The value of the `filesystems` attribute

  - ### pathMap

    public java.util.Map<java.lang.String,​WXM1ZFSFilesystem> pathMap()
    Specified by:
      `pathMap` in interface `WXM1ZFSFilesystemsType`
    Returns:
      The computed-at-construction value of the `pathMap` attribute

  - ### withFilesystems

    public final WXM1ZFSFilesystems withFilesystems​(WXM1ZFSFilesystem... elements)
    Copy the current immutable object with elements that replace the content of `filesystems`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFilesystems

    public final WXM1ZFSFilesystems withFilesystems​(java.lang.Iterable<? extends WXM1ZFSFilesystem> elements)
    Copy the current immutable object with elements that replace the content of `filesystems`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of filesystems elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `WXM1ZFSFilesystems` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `filesystems`, `pathMap`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `WXM1ZFSFilesystems` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### of

    public static WXM1ZFSFilesystems of​(java.util.List<WXM1ZFSFilesystem> filesystems)
    Construct a new immutable `WXM1ZFSFilesystems` instance.
    Parameters:
      `filesystems` - The value for the `filesystems` attribute
    Returns:
      An immutable WXM1ZFSFilesystems instance

  - ### of

    public static WXM1ZFSFilesystems of​(java.lang.Iterable<? extends WXM1ZFSFilesystem> filesystems)
    Construct a new immutable `WXM1ZFSFilesystems` instance.
    Parameters:
      `filesystems` - The value for the `filesystems` attribute
    Returns:
      An immutable WXM1ZFSFilesystems instance

  - ### copyOf

    public static WXM1ZFSFilesystems copyOf​(WXM1ZFSFilesystemsType instance)
    Creates an immutable copy of a `WXM1ZFSFilesystemsType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable WXM1ZFSFilesystems instance

  - ### builder

    public static WXM1ZFSFilesystems.Builder builder()
    Creates a builder for `WXM1ZFSFilesystems`.

         WXM1ZFSFilesystems.builder()
            .addFilesystems|addAllFilesystems(WXM1ZFSFilesystem) // filesystems elements
            .build();

    Returns:
      A new WXM1ZFSFilesystems builder